// setup steps:
//
// npm install jsdom jquery
// node build.js

var jsdom = require("jsdom");
var jQuery = require("jquery")(jsdom.jsdom().createWindow())
var fs = require("fs");

var log = console.log;

var container = '<div id="carea_hwi_assistant"/>';
var mainPage='#carea_hwi_internal';

//template section
var html = '<!DOCTYPE html>\n<html>\n<head>\n<link rel="stylesheet" type="text/css" href="../css/hwi_assistant.css" />  \n</head>\n<body id="carea_hwi_assistant">\n<div id="carea_hwi_internal" class="cf">\n\t<div class="carea_hwi_top_div">\n\t\t<span class="img_parent"><span class="carea_hwi_image_div dumbell_image"></span></span>\n\t\t<span class="title_div indent_image">\n\t\t\t<p class="title padded_label">Healthy&nbsp;Weight Care Assistant</p>\n\t\t\t<div class="section_div" section="Heading"></div>\n\t\t</span>\n\t</div>\n\t<div id="carea_hwi_left_side">\n\t\t<div class="section_div" section ="Document">\n\t\t\t<div id="carea_hwi_documentation"></div>\n\t\t</div>\n\t\t<div class="section_div" section ="FamHx">\n\t\t\t<div id="carea_hwi_family_history"></div>\n\t\t</div>\n\t\t<div class="section_div" section ="Comorbidities">\n\t\t\t<div id="carea_hwi_risk_factors"></div>\n\t\t</div>\n\t\t<div class="section_div" section ="Dx">\n\t\t\t<div id="carea_hwi_diagnosis"></div>\n\t\t</div>\n\t</div>\n\t<div id="carea_hwi_right_side">\n\t\t<div class="section_div" section ="Eval">\n\t\t\t<div id="carea_hwi_evaluation"></div>\n\t\t</div>\n\t\t\n\t\t<div class="section_div" section ="Goals">\n\t\t\t<div id="carea_hwi_goals"></div>\n\t\t</div>\n\t\t<div class="section_div" section ="Resource">\n\t\t\t<div id="carea_hwi_motivations"></div>\n\t\t</div><div class="section_div" section ="FollUp">\n\t\t\t<div id="carea_hwi_follow_up">\n\t\t\t\t</div>\n\t\t</div>\t\t\n\t\t<div class="section_div" class="center" section ="Build"><input type="button" id="save_button" name ="save_button" class="save_button carea_button center fine_print" value="Build Documentation and Order Set"/></div>\t\n\t<div class="section_div" section ="Pathway">\n\t\t\t</div></div>\n</div>\n</body>\n</html>';

function onSalience(a,b){
  var x = jQuery(a).find(">salience").text();
  var y = jQuery(b).find(">salience").text();
  return ((y==""?0:y*1)-(x==""?0:x*1));
}

function loadSection(div,section_data, patient_data, intervention_data){
    //errorchecking
    var locDiv=div;
    if(div==undefined){return false;}
    var sectName = jQuery(section_data).find("name").text();
    //Part A-1: Create the Heading from section>text (displayText?)
    log("in loadSection, sectName="+sectName+", section_data="+jQuery(section_data).text());
    var headDiv=jQuery("<div/>").appendTo(div);
    jQuery(section_data).find(">text").each(function(){
        //if the section has a title row which contains text add a header row
        if(this!=undefined&&this!=""){
            addHeaderRow(headDiv,section_data,jQuery(this).text());
        }
    });
    //references
    jQuery(section_data).find('>reference').each(function(){
      addReference(headDiv,sectName,jQuery(this),"").addClass("intralink").addClass(sectName+"_reference");
    })
    //use section data to help with display controls.
    var myArray=jQuery(intervention_data).find("dataRow>sectionName").filter(function() { return(jQuery(this).text() === sectName) }).parent().sort(onSalience);
    jQuery(intervention_data).find("dataRow>sectionName").filter(function() { jQuery(this).text() === sectName }).parent().sort(onSalience);
    jQuery(myArray).each(function(){
        var dataRow=jQuery(this);//store the datarow
        var supData=dataRow.find(">supportData");
        var action='';dataRow.find(">action").each(function(){action+=resolveFormattingAction(jQuery(this).text(),"",supData,intervention_data,patient_data)+";";});
        //develop the classList from preconditions (control display)
        var classList='';dataRow.find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
        //create an block div to contain the datarow
        var rowdiv = jQuery("<div/>",{"class":classList}).appendTo(locDiv);
        //rowdiv.addClass(sectName+"_div_row");
        rowdiv.addClass("regular_text").addClass("center_align").addClass("div_row").addClass(sectName+"_div_row");;
        associateActions(rowdiv,action,intervention_data,patient_data);
        //if there is a subheading, include the subheading
        var subh = addSubHeaderRow(rowdiv,section_data,dataRow.find(">text"),"");
        //add references (not currently adding refernces on the datarow level - but we should be???)
        //dataRow.find('>reference').each(function(){    addReference(rowdiv,sectName,jQuery(this),classList);});
        //Part A-3: Load the dataFlows from the above dataRows into the dataRow div, create an inline div to store each dataFlow, add a default of silent to each data flow(?)
        dataRow.find(">dataFlow").each(function(){
          var classList='';//reset the classlist
          jQuery(this).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
          var flowdiv = jQuery("<div>",{"class":classList +" inline regular_text center_align"}).appendTo(rowdiv);
          var type = jQuery(this).find(">type").text();//only one type/dataflow
          log("processing type="+type);
          switch(type){
            case "textbox":addTextBoxDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "textarea":addTextAreaDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "checkbox":addCheckBoxDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "radiobutton":addRadioButtonDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "combobox":addComboBoxDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "button":addButtonDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "hidden":addHiddenDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "label":addLabelDataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "matrix-checkbox":addMatrixCBdataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
            case "matrix-radiobutton":addMatrixRBdataFlow(flowdiv,intervention_data,section_data,dataRow,this,patient_data);break;
          }
        });
    }); 
    //subsections
    jQuery(section_data).find(">subsection").each(function(){
        var text =  jQuery(this).text();
        var intDiv=jQuery("<div/>",{"class":jQuery(this).text()+" regular_text","section":text}).appendTo(div);
        loadSection(intDiv,jQuery(intervention_data).find("section>name").filter(function() {jQuery(this).text() === text}).first().parent(),patient_data,intervention_data);
    });
}
//adds a headerRow for a section
function addHeaderRow(div,section_data,text){
  //pull the section name into the class field to inplement localize css settings... _heading
  var sectName = jQuery(section_data).find(">name").text();
    if(valueExists(text)){jQuery("<span/>",{"class":"carea_heading "+sectName+"_heading"}).text(text).appendTo(div);}
}
//adds a subheading for a datarow
function addSubHeaderRow(div,section_data,text,altText){
  var sectName = jQuery(section_data).find(">name").text();
  //pull the section name into the class field to inplement localize css settings... _subheading
  var text=jQuery(text).text();
  if(valueExists(text)){
      var elem = jQuery("<span/>",{"class":"carea_subheading inline "+sectName+"_subheading"}).text(text);
      jQuery(div).append(elem);
      if(valueExists(jQuery(altText).text())){elem.attr("title",jQuery(altText).text());}
      return elem;
  } 
  return null;
}
/*INPUT CLASSES*/
function addTextBoxDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  //assumtion order - checkbox label references supportData
  //in future will need to allow for alternative DataFlow organization (at the sectionlevel?)
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var desc=jQuery(data_flow).find('>description').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var defaultText=jQuery(data_flow).find('>defaultText').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //if there is another element with this identity - pull the value
  if(valueExists(jQuery(data_flow).find('>text').text())){    addLabel(flowdiv,sectName,jQuery(data_flow).find('>text').text(),title,classList);}
  var linked = jQuery("input[type=text][data-identity="+identity+"]").val();
  //add the input textbox value-->name attribute
  var elem=addInput(flowdiv,"text",linked,"",title,classList,jQuery(data_flow).find('>defaultText').text(),defaultValue);
  jQuery(elem).addClass('textbox').addClass(sectName+'_textbox').attr("data-identity",identity).attr("data-noteDetails",desc).change(function (){reciprocity(this);});
  //actions
  associateActions(elem,action,intervention_data,patient_data);
  //other details
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv,sectName,jQuery(this),classList);});
  //jQuery(data_flow).find('>supportData').each(function(){    addSupportData(flowdiv,sectName,jQuery(this),classList);});
}
function addTextAreaDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var supData=jQuery(data_flow).find(">supportData");
  var desc=jQuery(data_flow).find('>description').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var defaultText=jQuery(data_flow).find('>defaultText').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //textArea label is a seperate row above text area (with support and reference data)
  var flowdiv2 = jQuery("<div/>",{"class":classList +" block regular_text center_align"}).appendTo(flowdiv);
  if(valueExists(jQuery(data_flow).find('>text').text())){addLabel(flowdiv2,sectName,jQuery(data_flow).find('>text').text(),title,classList);}
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv2,sectName,jQuery(this),classList);  });
  //jQuery(data_flow).find('>supportData').each(function(){    addSupportData(flowdiv2,sectName,jQuery(this),classList);  });
  //add the input textarea value-->name attribute
  var linked = jQuery("input[type=text][data-identity="+identity+"]").val();
  var elem =jQuery("<textarea/>",{"data-identity":identity,"class":"block regular_text center_align "+classList}).attr("data-noteDetails",desc).val(linked).appendTo(flowdiv);
  //jQuery(elem).addClass('textarea').addClass(sectName+'_textarea').change(function (){reciprocity(this);});
  //actions
  associateActions(elem,action,intervention_data,patient_data);
  //other details
  if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
  if(valueExists(defaultValue)){jQuery(elem).attr("value",defaultValue);}
  if(valueExists(defaultText)){jQuery(elem).attr("placeholder",defaultText);} 
}
function addCheckBoxDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  //assumtion order - checkbox label references supportData
  //in future will need to allow for alternative DataFlow organization (at the sectionlevel?)
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var supData=jQuery(data_flow).find(">supportData");
  var desc=resolveFormattingAction(jQuery(data_flow).find('>description').text(),identity,supData,intervention_data,patient_data);
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var defaultText=jQuery(data_flow).find('>defaultText').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //scan the system
  var linked = jQuery("input[type=checkbox][data-identity="+identity+"]").attr('checked');
  if(!valueExists(linked)){linked=false;}
  //add the input
  var  elem = addInput(flowdiv,"checkbox","","",title,classList,"",defaultValue).attr('checked',linked); 
  jQuery(elem).addClass('checkbox').addClass(sectName+"_checkbox").attr("data-identity",identity).attr("data-noteDetails",desc).click(function (){reciprocity(this);});
  //actions
  associateActions(elem,action,intervention_data,patient_data);
  //add label and support/reference
  if(valueExists(jQuery(data_flow).find('>text').text())){    addLabel(flowdiv,sectName,jQuery(data_flow).find('>text').text(),title,classList);  }
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv,sectName,jQuery(this),classList);  });
  //jQuery(data_flow).find('>supportData').each(function(){    addSupportData(flowdiv,sectName,jQuery(this),classList);  });
}
function addRadioButtonDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var supData=jQuery(data_flow).find(">supportData");
  var desc=resolveFormattingAction(jQuery(data_flow).find('>description').text(),identity,supData,intervention_data,patient_data);
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //scan the system
  var linked = jQuery("input[type=radio][data-identity="+identity+"]").attr('checked');
  if(!valueExists(linked)){linked=false;}
  //add the input - radioButtons have pre_sect_post as value AND sectName-->name
  var elem = addInput(flowdiv,"radio","","",title,classList,"",defaultValue).attr('checked',linked);
  jQuery(elem).addClass('radiobutton').addClass(sectName+"_radiobutton").attr("name",sectName+jQuery(data_row).find('>name').text()).attr("data-identity",identity).attr("data-noteDetails",desc).click(function (){reciprocity(this);});
  //actions
  //.click(function(){alert((jQuery(this).attr(name))+" hi");})
  associateActions(elem,action,intervention_data,patient_data);
  //add other dataflow
  if(valueExists(jQuery(data_flow).find('>text').text())){    addLabel(flowdiv,sectName,jQuery(data_flow).find('>text').text(),title,classList);  }
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv,sectName,jQuery(this),classList);  });
 // jQuery(data_flow).find('>supportData').each(function(){    addSupportData(flowdiv,sectName,jQuery(this),classList);  });
}
function addComboBoxDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //label and reference
  if(valueExists(jQuery(data_flow).find('>text').text())){addLabel(flowdiv,sectName,jQuery(data_flow).find('>text').text(),title,classList);}  
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv,sectName,jQuery(this),classList);  });
  //add the input - radioButtons have pre_sect_post as value AND sectName-->name
  var elem =jQuery("<select/>",{"class":"inline regular_text center_align "+classList,"type":type}).appendTo(flowdiv);
  jQuery(elem).addClass('combobox').addClass(sectName+"_combobox").attr("data-identity",identity).click(function (){reciprocity(this);});
  associateActions(elem,action,intervention_data,patient_data);
  if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
  //add default option
  var opt =jQuery("<option/>",{"class":"inline regular_text center_align "+classList}).appendTo(flowdiv);
  jQuery(opt).addClass('option').addClass(sectName+"_option");
  jQuery(opt).text("Please select");  
  //add the options
  jQuery(data_flow).find("answer").each(function(){
    //create an option for each answer
      var identity=jQuery(this).find('>prefix').text()+jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text()+jQuery(this).find('>postfix').text();
      var title=jQuery(data_flow).find('>altText').text();
      var defaultValue=jQuery(data_flow).find('>defaultValue').text();
      var answerAction='';jQuery(this).find(">action").each(function(){action+=jQuery(this).text()+";";});
      var classList='';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
      var opt =jQuery("<option/>",{"data-identity":identity,"class":"inline regular_text center_align "+classList}).appendTo(flowdiv);
      jQuery(opt).addClass('option').addClass(sectName+"_option");
      //actions
      associateActions(opt,answerAction);
      //other aspects
      if(valueExists(jQuery(this).find('>text').text())){jQuery(opt).text(jQuery(this).find('>text').text());}
      if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
      if(valueExists(defaultValue)){jQuery(elem).attr("selected",defaultValue);}
  });
 // jQuery(data_flow).find('>supportData').each(function(){addSupportData(flowdiv,sectName,jQuery(this),classList);});
}
function addLabelDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  var title=jQuery(data_flow).find('>altText').text();
  var supData=jQuery(data_flow).find(">supportData");
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var desc=resolveFormattingAction(jQuery(data_flow).find('>description').text(),identity,supData,intervention_data,patient_data);
  var action='';jQuery(data_flow).find(">action").each(function(){action+=resolveFormattingAction(jQuery(this).text(),"",supData,intervention_data,patient_data)+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //label and reference
  if(valueExists(jQuery(data_flow).find('>text').text())){ 
    var elem = addLabel(flowdiv,sectName,jQuery(data_flow).find('>text').text(),title,classList);
    resolveFormatting(elem,"",supData,intervention_data,patient_data);    
    jQuery(elem).addClass('dataflow_label').addClass(sectName+'_dataflow_label').attr("data-identity",identity).attr("data-noteText",title).attr("data-noteDetails",desc);
    //label actions
    if(action.length>0){jQuery(elem).addClass('dataflow_label_intralink');}//actionable dataflowlink
    associateActions(elem,action,intervention_data,patient_data);
  }  
}
function addButtonDataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var defaultText=jQuery(data_flow).find('>defaultText').text();
  var action='';jQuery(data_flow).find(">action").each(function(){action+=jQuery(this).text()+";";});
  var classList='inherit ';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  var elem = addInput(flowdiv,"button",jQuery(data_flow).find('>text').text(),title,"",classList,"",defaultValue);
  jQuery(elem).addClass('button').addClass(sectName+'_button').attr("data-identity",identity);
  associateActions(elem,action,intervention_data,patient_data);
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv,sectName,jQuery(this),classList);  });
  //jQuery(data_flow).find('>supportData').each(function(){    addSupportData(flowdiv,sectName,jQuery(this),classList);  });
}
function addMatrixCBdataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  //var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var classMatrix='matrix '+sectName+'_matrix';
  var classList='';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //label and reference
  var flowdiv2 = jQuery("<div/>",{"class":classList +" block regular_text center_align"}).appendTo(flowdiv);
  if(valueExists(jQuery(data_flow).find('>text').text())){addLabel(flowdiv2,sectName,jQuery(data_flow).find('>text').text(),title,classList);}
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv2,sectName,jQuery(this),classList);  });
  //add the matrix
  var table = jQuery("<table/>",{"class":classMatrix}).appendTo(flowdiv);
  var tr = jQuery("<tr/>",{"class":classMatrix}).appendTo(table);
  //corner cell - spacer
  jQuery("<td/>",{"class":classMatrix}).appendTo(tr).css("width",function(){
        /**NEEDS WORK!**/
        //only should be adjusting for header if 
        //1- datarow text, or 2 - sectionName text AND matrix is first data-flow
        var ii = jQuery(section_data).find(">text").text().length;
        var jj = jQuery(data_row).find(">text").text().length;
        return (jj>0?(jj+4)*8+'px':ii*8+'px');//account for subheading indent with 2letters extra
      });
  //header row
  jQuery(data_flow).find(">answer").each(function(){
    //create an option for each answer
    var title=jQuery(this).find('>altText').text();
    var txt=jQuery(this).find('>text').text();
    var classList='';jQuery(this).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
    if(valueExists(jQuery(this).find(">revisedType").text())){
        addLabelCell(tr,sectName,"",title,classList+classMatrix+" answer_head"); 
    }
    else if(valueExists(txt)){addLabelCell(tr,sectName,txt,title,classList+classMatrix+' answer_head');};
  });
  //other rows
  jQuery(data_flow).find(">question").each(function(){
    var tr = jQuery("<tr/>",{"class":classMatrix}).appendTo(table);
    jQuery(tr).addClass("div_row");
    var mIdentity=jQuery(this).find('>prefix').text()+jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text()+jQuery(this).find('>postfix').text();
    var title=jQuery(this).find('>altText').text();
    var txt=jQuery(this).find('>text').text();
    var supData=jQuery(this).find('>supportData');
    var classList='';jQuery(this).find(">precondition").each(function(){
      var txt = jQuery(this).text();
      classList+=txt+" ";
      jQuery(tr).addClass(txt);
    });  
    //first column
    var elem = jQuery("<td/>",{"class":classList+classMatrix+" regular_text matrix_question "+sectName+"_matrix_question"}).appendTo(tr);
    if(valueExists(txt)){jQuery(elem).text(txt);}  
    if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title); }
    //other columns
    jQuery(data_flow).find(">answer").each(function(){
      var identity=jQuery(this).find('>prefix').text()+mIdentity+jQuery(this).find('>postfix').text();
      var action='';jQuery(this).find(">action").each(function(){
        action+=resolveFormattingAction(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+";";
      });
      var title=jQuery(this).find('>altText').text();
      var txt=jQuery(this).find('>text').text();
      var rt = jQuery(this).find('>revisedType').text();
      var classList='inherit ';jQuery(this).find(">precondition").each(function(){classList+=resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+" ";});
      //alert(classList);
      var td = jQuery("<td/>",{"class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer"}).appendTo(tr);
      if(!valueExists(rt)){
        var linked = jQuery("input[type=checkbox][data-identity="+identity+"]").attr('checked');
        if(!valueExists(linked)){linked=false;}
        var elem = jQuery("<input/>",{"type":"checkbox","class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer checkbox "+sectName+"_checkbox","data-identity":identity}).click(function(){reciprocity(this);}).attr('checked',linked).attr("data-answer",txt).appendTo(td);
      }
      else{
         switch(rt){
            case "textbox":
              var linked = jQuery("input[type=text][data-identity="+identity+"]").val();
              var elem = jQuery("<input/>",{"type":"text","class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer textbox matrix_textbox "+sectName+"_textbox","data-identity":identity}).click(function(){reciprocity(this);}).val(linked).appendTo(td);       
              break;
            case "button":
              var elem = jQuery("<input/>",{"type":"button","class":classList+classMatrix+" button matrix_button "+sectName+"_button " + sectName+"_matrix_button","value":txt,"data-identity":identity}).click(function(){reciprocity(this);}).appendTo(td);
              break;
            case "label":
              var elem = jQuery("<td/>",{"class":classList+" matrix_label"}).appendTo(tr);
                if(valueExists(txt)){
                  jQuery(elem).text(txt);
                  resolveFormatting(elem,mIdentity,supData,intervention_data,patient_data);
                }  
                if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
              break;
          } 
      }
      associateActions(elem,action,intervention_data,patient_data);
    });
  });
  //add the support data (if)
  //jQuery(data_flow).find('>supportData').each(function(){addSupportData(flowdiv,sectName,jQuery(this),classList);});
}
function addMatrixRBdataFlow(flowdiv,intervention_data,section_data,data_row,data_flow,patient_data){
  var sectName = jQuery(section_data).find(">name").text();
  //var identity=jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text();
  var title=jQuery(data_flow).find('>altText').text();
  var defaultValue=jQuery(data_flow).find('>defaultValue').text();
  var classMatrix='matrix '+sectName+'_matrix';
  var classList='';jQuery(data_flow).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
  //label and reference
  var flowdiv2 = jQuery("<div/>",{"class":classList +" block regular_text center_align"}).appendTo(flowdiv);
  if(valueExists(jQuery(data_flow).find('>text').text())){addLabel(flowdiv2,sectName,jQuery(data_flow).find('>text').text(),title,classList);}
  jQuery(data_flow).find('>reference').each(function(){    addReference(flowdiv2,sectName,jQuery(this),classList);  });
  //add the matrix
  var table = jQuery("<table/>",{"class":classMatrix}).appendTo(flowdiv);
  var tr = jQuery("<tr/>",{"class":classMatrix}).appendTo(table);
  //corner cell - spacer
  jQuery("<td/>",{"class":classMatrix}).appendTo(tr).css("width",function(){
        /**NEEDS WORK!**/
        //only should be adjusting for header if 
        //1- datarow text, or 2 - sectionName text AND matrix is first data-flow
        var ii = jQuery(section_data).find(">text").text().length;
        var jj = jQuery(data_row).find(">text").text().length;
        return (jj>0?(jj+4)*8+'px':ii*8+'px');//account for subheading indent with 2letters extra
      });
  //header row
  jQuery(data_flow).find(">answer").each(function(){
    //create an option for each answer
    var title=jQuery(this).find('>altText').text();
    var txt=jQuery(this).find('>text').text();
    var classList='';jQuery(this).find(">precondition").each(function(){classList+=jQuery(this).text()+" ";});
    if(valueExists(jQuery(this).find(">revisedType").text())){
        addLabelCell(tr,sectName,"",title,classList+classMatrix+" answer_head"); 
    }
    else if(valueExists(txt)){addLabelCell(tr,sectName,txt,title,classList+classMatrix+' answer_head');};
  });
  //other rows
  jQuery(data_flow).find(">question").each(function(){
    var tr = jQuery("<tr/>",{"class":classMatrix}).appendTo(table);
    jQuery(tr).addClass("div_row");
    var mIdentity=jQuery(this).find('>prefix').text()+jQuery(data_flow).find('>prefix').text()+jQuery(data_row).find('>name').text()+jQuery(data_flow).find('>postfix').text()+jQuery(this).find('>postfix').text();
    var title=jQuery(this).find('>altText').text();
    var txt=jQuery(this).find('>text').text();
    var supData=jQuery(this).find('>supportData');
    var classList='';jQuery(this).find(">precondition").each(function(){
      var txt = jQuery(this).text();
      classList+=txt+" ";
      jQuery(tr).addClass(txt);
    });  //first column
    var elem = jQuery("<td/>",{"class":classList+classMatrix+" regular_text matrix_question "+sectName+"_matrix_question"}).appendTo(tr);
    if(valueExists(txt)){jQuery(elem).text(txt);}  
    if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title); }
    //other columns
    jQuery(data_flow).find(">answer").each(function(){
      var identity=jQuery(this).find('>prefix').text()+mIdentity+jQuery(this).find('>postfix').text();
      var title=jQuery(this).find('>altText').text();
      var txt=jQuery(this).find('>text').text();
      var rt = jQuery(this).find('>revisedType').text();
      var action='';jQuery(this).find(">action").each(function(){
        action+=resolveFormattingAction(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+";";
      });
      var classList='inherit ';jQuery(this).find(">precondition").each(function(){classList+=resolveFormattingText(jQuery(this).text(),mIdentity,supData,intervention_data,patient_data)+" ";});
      var td = jQuery("<td/>",{"class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer"}).appendTo(tr);
      if(!valueExists(rt)){
        var linked = jQuery("input[type=radio][data-identity="+identity+"]").attr('checked');
        if(!valueExists(linked)){linked=false;}
        var elem = jQuery("<input/>",{"type":"radio","class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer radiobutton "+sectName+"_radiobutton","data-identity":identity}).attr('checked',linked).click(function(){reciprocity(this);}).appendTo(td);
        jQuery(elem).attr("name",mIdentity).attr("data-answer",txt);        
      }
      else{
         switch(rt){
            case "textbox":
              var linked = jQuery("input[type=text][data-identity="+identity+"]").val();
              var elem = jQuery("<input/>",{"type":"text","class":classList+classMatrix+" matrix_answer "+sectName+"_matrix_answer textbox matrix_textbox "+sectName+"_textbox","data-identity":identity}).click(function(){reciprocity(this);}).val(linked).appendTo(td);       
              break;
            case "button":
              var elem = jQuery("<input/>",{"type":"button","class":classList+classMatrix+" button matrix_button "+sectName+"_button " + sectName+"_matrix_button","value":txt,"data-identity":identity}).click(function(){reciprocity(this);}).appendTo(td);
              break;
            case "label":
              var elem = jQuery("<td/>",{"class":classList+" matrix_label"}).appendTo(tr);
                if(valueExists(txt)){
                  jQuery(elem).text(txt);
                  resolveFormatting(elem,mIdentity,supData,intervention_data,patient_data);
                }  
                if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
              break;
          }
      }
      associateActions(elem,action,intervention_data,patient_data);
    });
  });
  //add the support data (if)
  //jQuery(data_flow).find('>supportData').each(function(){addSupportData(flowdiv,sectName,jQuery(this),classList);});
}
function addLabelCell(tr,sectName,txt,title,classList){
    var elem = jQuery("<td/>",{"class":classList}).appendTo(tr);
    if(valueExists(txt)){jQuery("<span/>",{"class":"regular_text "+classList}).text(txt).appendTo(elem);}  
    if(valueExists(title)){elem.attr("title",title);elem.attr("alt",title);}
    return elem;
  }

//GENERIC ADD INPUT FCNS
function addInput(flowdiv,type,value,text,title,classList,defaultText,defaultValue,action){
  var elem =jQuery("<input/>",{"value":value,"class":"inline regular_text center_align "+classList,"type":type}).appendTo(flowdiv);
  if(valueExists(title)){elem.attr("title",title);elem.attr("alt",title);}
  if(valueExists(defaultValue)){elem.attr("checked",defaultValue);}
  if(valueExists(defaultText)){elem.attr("placeholder",defaultText);}
  return elem;
}
function openWindow(sent){
    //local and server based opening handled using CAREA_DEBUG check
    if(sent.indexOf("http")!=-1){
      window.open(sent,"_blank","toolbar=no, status=no,menubar=no,location=no,titlebar=no,navigation=no,width=900,height=700,resizable=yes,scrollbars=yes");
    }
    else{
      window.open(window.CAREA_DEBUG?"http://localhost:8003/"+sent:Config.InterventionServer+"interventions/hwi-assistant/"+sent,"_blank","toolbar=no, status=no,menubar=no,location=no,titlebar=no,navigation=no,width=900,height=700");
    }
}
function openWebsite(sent){
    //local and server based opening handled using CAREA_DEBUG check
    window.open(sent,"_blank","toolbar=no,status=no,menubar=no,location=no,titlebar=no,navigation=no,width=900,height=700,resizable=yes,scrollbars=yes",false);
}

function associateActions(elem,actionList,intervention_data,patient_data){
  if(valueExists(actionList)){
    jQuery(elem).attr('data-action',actionList);
    //1 - split on ";"
    var soa = actionList.split(";");
    var tmp="";
    for(var ii=0;ii<soa.length-1;ii++){

      var actionClass=soa[ii].substring(0,soa[ii].indexOf("::"));
      var tgt =soa[ii].substring(soa[ii].indexOf("::")+2);
      //onload actions
      switch(actionClass){
            case "show":break;
            case "click":break;
            case "apply":break;
            case "order":break;
            case "diagnosis":break;
            case "revise":break;//indicate a element to change in the future
            case "revised":
              elem.attr("data-revised",tgt);
              break;
            case "require":
              //if there is no data the first char of tgt will be % or tgt length will be 0 (if prefromatted)
              if(tgt.indexOf("%")==0||tgt.length==0){jQuery(elem).text("");}
              break;
            case "intralink":
            case "link":
                jQuery(elem).addClass("intralink");break;
            case "flagSilent":
             applyFlag(tgt,elem,false); break;
            case "flag":
              applyFlag(tgt,elem,true); break;
             
      }
      //delayed actions use stored variable function method
      jQuery(elem).click((function(actionClass,tgt){
        return function(){
          switch(actionClass){
            case "show":
              createWindow(tgt,intervention_data,patient_data);
             break;
            case "click":
              jQuery("[data-identity="+tgt+"]:not(:checked)").click();
              break;
            case "apply":break;
            case "order":break;
            case "revise":
              reviseElem(tgt);break;
            case "diagnosis":break;
            case "intralink":
              openWindow(tgt);break;
            case "link":
              openWebsite(tgt);break;
          }
        };
      }(actionClass,tgt)));
    } 
  } 
}
function reviseElem(stmt){
  var elem = jQuery("[data-identity="+stmt+"]");
  //locate the element and apply the revised text
  var str = elem.attr("data-revised");
  var attr=str.substring(0,str.indexOf("("));
  var val =str.substring(str.indexOf("(")+1,str.length-1);
  switch(attr){
    case 'text':jQuery(elem).text(resolveSubText(val));break;
    default:jQuery(elem).attr(attr,resolveSubText(val));
  }
}
function resolveSubText(stmt){
   stmt = stmt.replace("%datetime",timeStamp());
   return stmt;
}
function applyFlag(stmt,elem,use_title){
  //breakdownstatement - flag and eval statement
  var soa = stmt.split("(");
  var flag = soa[0];
  if(soa.length==1){
    jQuery(elem).addClass(flag);
    
    var sp = jQuery(elem).append(jQuery("<span/>").addClass(flag+"_after"));//.offset(pos.left,pos.top);
    if(use_title){
      jQuery(sp).attr("title",flag + "(" + displayDateTime(jQuery(elem).attr("data-time"))+")");
    }
     createAssertion(jQuery(elem).attr("data-identity")+"_"+flag);
    //triggerCascade(jQuery(elem).attr("data-identity")+"_"+flag,1,jQuery("#carea_hwi_assistant"));
    return;
  }
  try{
    var determine = soa[1].substring(0,soa[1].length-1);
    //use an eval statement to do comparison
    if(eval(determine)){
      jQuery(elem).addClass(flag);
      var sp = jQuery(elem).append(jQuery("<span/>").addClass(flag+"_after"));//.offset(pos.left,pos.top);
      if(use_title){ 
        jQuery(sp).attr("title",flag + " (" + displayDateTime(jQuery(elem).attr("data-time"))+")");
      }
      //log(jQuery(elem).attr("data-identity")+"_"+flag);
      createAssertion(jQuery(elem).attr("data-identity")+"_"+flag);
      //triggerCascade(jQuery(elem).attr("data-identity")+"_"+flag,1,jQuery("#carea_hwi_assistant"));
    }
  }
  catch(err){log("Could not evaluate this statement: "+stmt)}
    //var actionClass=soa[ii].substring(0,soa[ii].indexOf("::"));
    //var tgt =soa[ii].substring(soa[ii].indexOf("::")+2);
  
  //if eval true add the flag as a class, also should do sectName_flag, but that is not currently supported.

}
function addLabel(flowdiv,sectName,text,title,classList){
  var elem = jQuery("<span/>",{"class":"inline label regular_text center_align "+classList+" "+sectName+"_label","textContent":text,"innerText":text}).appendTo(flowdiv);
  if(valueExists(title)){jQuery(elem).attr("title",title);jQuery(elem).attr("alt",title);}
  return elem;
}
function addReference(flowdiv,sectName,reference,classList){
  var elem;
  //reference is either a text or an image as the link
  var val=jQuery(reference).find('>text').text();
  if(valueExists(val)){
    elem =jQuery("<a/>",{"class":"regular_text padded_label "+classList+" reference "+sectName+"_reference"}).text(val);
  }
  else{elem =jQuery("<span/>",{"class":"preview_image "+classList+" reference "+sectName+"_reference"});  }
  jQuery(elem).appendTo(flowdiv);//.addClass("keeper");
  //target is a file or a url
  var href = jQuery(reference).find('href').text();
  if(valueExists(href)){
    jQuery(elem).attr("url",href).addClass("intralink");
  }
  var file = jQuery(reference).find('file').text();
  if(valueExists(file)){
    jQuery(elem).attr("url",file).addClass("intralink");
  }
  if(href.length>0||file.length>0){
    jQuery(elem).click(function(){openWindow(jQuery(elem).attr("url"));});
  }
  return elem;
}
// resolve %indexs from XML within a DOM element
function resolveFormatting(elem,lnk,keys,intervention_data,patient_data){
  var txt = jQuery(elem).text();
  if(valueExists(txt)){
    jQuery(elem).text(jQuery(elem).text().replace('%q.',''));//should not need %q in %1 call, %q is assumed in matrix
    jQuery(elem).text(jQuery(elem).text().replace('%q',lnk));//replace without dot using lnk
    //replace keys
    if(valueExists(keys)){
      var arr = jQuery.makeArray(keys);
      var jj=1;
      for(var val in arr){
        //grab the data
        var rep=determineReferenceData(jQuery(arr[val]).text(),patient_data,intervention_data,elem);
        jQuery(elem).html(jQuery(elem).text().replace('%'+jj++,rep));
      }
    }
  }
}
//For text (class name)
function resolveFormattingText(txt,lnk,keys,intervention_data,patient_data){
  if(valueExists(txt)){
    txt=txt.replace('%q.','');//should not need %q in %1 call, %q is assumed in matrix
    txt=txt.replace('%q',lnk);//replace without dot using lnk
    //replace keys
    if(valueExists(keys)){
      var arr = jQuery.makeArray(keys);
      var jj=1;
      for(var val in arr){
        //grab the data
        txt=txt.replace('%'+jj++,jQuery(arr[val]).text());
      }
    }
    return txt;
  }
  return txt;
}
//For text (actions...)
function resolveFormattingAction(txt,lnk,keys,intervention_data,patient_data){
  if(valueExists(txt)){
    txt=txt.replace('%q.','');//should not need %q in %1 call, %q is assumed in matrix
    txt=txt.replace('%q',lnk);//replace without dot using lnk
    //replace keys
    if(valueExists(keys)){
      var arr = jQuery.makeArray(keys);
      var jj=1;
      for(var val in arr){
        //grab the data
        var rep=determineReferenceData(jQuery(arr[val]).text(),patient_data,intervention_data);
        //log(rep);
        txt=txt.replace('%'+jj++,rep);
      }
    }
    return txt;
  }
  return txt;
}
function determineReferenceData(txt,patient_data,intervention_data,elem){
  return jQuery("<p/>").addClass("inline").text(txt).html();
}
function createWindow(sectName,intervention_data,patient_data){
    //access the div locator
    var target=jQuery(mainPage);
    //look for the div (name based search)
    var div = jQuery(mainPage +">div[section='"+sectName+"']")[0];
    //if the div exists - change state from hidden to show
    if(div!=undefined){
       jQuery(div).removeClass("silent");
       if(jQuery(div).find(".float_label").length==0){
        jQuery(event.srcElement).attr("backup",jQuery(event.srcElement).val());//save the base value
        addTopEscape(div,event.srcElement);//top exit button      
       }
   }    
}
function addTopEscape(div,source){
    var lnk = jQuery("<label/>",{"class":"intralink fine_print float_label fixed"}).text("Clear Section").appendTo(div);
    lnk.offset({"top":jQuery(div).offset()["top"]+5,"left":jQuery(div).offset()["left"]+jQuery(div).width()-125});
    //clear all values and return to default
    jQuery(lnk).click(function(){
        jQuery(div).find(":checked").removeAttr('checked');
        jQuery(div).find("textarea,input[type=text]").val('');
        jQuery(div).find("select").val('0');
    });
    //hide documentation window
    var lnk = jQuery("<label/>",{"class":"intralink fine_print float_label fixed"}).text("Save/Exit").appendTo(div);
    lnk.offset({"top":jQuery(div).offset()["top"]+5,"left":jQuery(div).offset()["left"]+jQuery(div).width()-55});
    jQuery(lnk).click(function(){
        jQuery(div).addClass("silent");
        var x = jQuery(div).find(":checked,textarea:not(:empty),input[type=text]:not(:empty)");
        if(x.length>0){
          var txt = reviewText(div);
          jQuery(source).val("Review").attr("title",txt).attr('data-internal',txt).hover(function(){jQuery(source).val("Revise");},function(){jQuery(source).val("Review"); });
        }
        else{
          jQuery(source).unbind("mouseenter mouseleave").val(jQuery(source).attr("backup")).attr("title","").attr('data-internal',""); 
        }
    });
}
function reviewText(div){
    var snake="";
    //checkboxes/radio - not matrix
    jQuery(div).find(":checked").not(".matrix_answer").each(function(){
      snake+=jQuery(this).parents("div.div_row").find(".dataflow_label:first").text()+" - "+jQuery(this).parent("div").find(".label").text()+"\n";
    })
    //checkboxes from a matricks
    jQuery(div).find(":checked").filter(".matrix_answer").each(function(){
      snake+=jQuery(this).parents("tr.div_row").find(".matrix_question").text()+" : "+jQuery(this).attr('data-answer')+"\n";
    });
    jQuery(div).find("textarea:not(:empty),input[type=text]:not(:empty)").each(function(){
      snake+=jQuery(this).parents("div.div_row").find(".label:first").text()+" : "+jQuery(this).text()+"\n";
    });
    return snake;
}
//pull a value from a particular place in the patient object
function lookupValueScrape(scrape,link,identifier){
  //for working with raw data
  /*for(var ii=0;ii<scrape.length;ii++){
    //i
    if(equalsIgnoreCase(scrape[ii]["type"],link)){
      if(scrape[ii][identifier]!=null){
        return scrape[ii][identifier];
      }
    }
  }*/
  if(scrape[link][identifier]!=null){
    return scrape[link][identifier];
  }
  log("Could not find in patient object: section="+link+", with instance of "+identifier);
  return "";
}

/**
* Support Classes
**/
//generates a visual time stamp
function timeStamp() {
  //reference: https://gist.github.com/hurjas/2660489
// Create a date object with the current time
  var now = new Date();
  // Create an array with the current month, day and time
  var date = [ now.getMonth() + 1, now.getDate(), now.getFullYear() ];
  // Create an array with the current hour, minute and second
  var time = [ now.getHours(), now.getMinutes()];//, now.getSeconds() 
  // Determine AM or PM suffix based on the hour
  var suffix = ( time[0] < 12 ) ? "AM" : "PM";
  // Convert hour from military time
  time[0] = ( time[0] < 12 ) ? time[0] : time[0] - 12;
  // If hour is 0, set it to 12
  time[0] = time[0] || 12;
  // If seconds and minutes are less than 10, add a zero
  for ( var i = 1; i < 2; i++ ) {//3 removed seconds
    if ( time[i] < 10 ) {
    time[i] = "0" + time[i];
    }
  }
  // Return the formatted string
  return time.join(":") + " " + suffix+" "+date.join("/");
}
function displayDateTime(date_sent){
var date = [ date_sent.substring(5,7), date_sent.substring(8,10), date_sent.substring(0,4) ];
  // Create an array with the current hour, minute and secon
  // Return the formatted string
  return date.join("/");
}
//style application for stribed table appearance, applied as css directly to override IE behavior in EPIC
function zebraTables(repr){
  jQuery(repr).find('table').find("tr:not(:first):not(.hidden):even").css("background-color", "#FFFFFF");
  jQuery(repr).find('table').find("tr:not(:first):not(.hidden):odd",'table').css("background-color", "#D6D6D6");
}

//fix for attr placeholder in IE7, QUIRKSMODE
function allowPlaceholder(doc){
  //www.hagenburger.net/BLOG/HTML5-Input-Placeholder-Fix-With-jQuery.html - adapted
  // Released under MIT license: http://www.opensource.org/licenses/mit-license.php
    jQuery('[placeholder]',doc).focus(function() {
    var input = jQuery(this);
    if (input.val() == input.attr('placeholder')) {
      input.val('');
      input.removeClass('placeholder');
    }
    }).blur(function() {
      var input = jQuery(this);
      if (input.val() == '' || input.val() == input.attr('placeholder')) {
        input.addClass('placeholder');
        input.val(input.attr('placeholder'));
      }
    }).blur().parents('form').submit(function() {
      jQuery(this).find('[placeholder]',doc).each(function() {
        var input = jQuery(this);
        if (input.val() == input.attr('placeholder')) {
          input.val('');
        }
      })
    });
}

//check if an object exists
function exists(param){return typeof param !== 'undefined';}
//check if a value exists
function valueExists(param) {return exists(param)&&param!="";}
//string comparator
function equalsIgnoreCase(str1,str2){
  return str1===str2||valueExists(str1)&&valueExists(str2)&&str1.toUpperCase().match(str2.toUpperCase());
}

function getNodeByValue(xml, selector, value) {
  var result = null;
  jQuery(xml).find(selector).each(function() {
    if (jQuery(this).text() === value) {
      console.log("Found: " + value);
      result = jQuery(this);
    }
  });
  return result;
}

fs.readFile('../data/hwi_xmlSource.xml', 'utf8', function(err, xml) {
  if (err) throw err;

  var repr = jQuery(container);
  repr.append(html);
  jQuery("div.section_div",repr).each(function(){
    var sectName = jQuery(this).attr('section');
    log("processing section name:" + sectName);

    var sect = getNodeByValue(xml, "section>name", sectName);
    if(sect != null) {
      var div = jQuery(this).addClass(sectName);//section as a class
      loadSection(jQuery(this),sect.parent(),{},xml);
    }

  });

  //preload all other sections
  var sects = jQuery(xml).find("section");
  for(var ii=0;ii<sects.length;ii++){
    var name = jQuery(sects[ii]).find(">name").text();
    log("preload section name:" + name);
    if(!jQuery(repr).find("div."+name).length){
      var div = jQuery("<div/>",{"class":name,"section":name}).appendTo(jQuery(mainPage,repr));
      jQuery(div).addClass("defaultPopUp").addClass("silent");
      loadSection(div,sects[ii],{},xml);
    }
  }

  fs.writeFile("../html/hwi_assistant.html", repr.html(), function(err) {
    if(err) {
      log(err);
    } else {
      log("The file ../html/hwi_assistant.html was saved!");
    }
  }); 
});


